# coding: utf-8

"""
    Ours

    The Ours Server-Side REST API

    The version of the OpenAPI document: 1.0.0
    Contact: support@oursprivacy.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from oursprivacy_client.models.track_request_default_properties import TrackRequestDefaultProperties
from oursprivacy_client.models.track_request_user_properties import TrackRequestUserProperties
from typing import Optional, Set
from typing_extensions import Self

class TrackRequest(BaseModel):
    """
    TrackRequest
    """ # noqa: E501
    event: Annotated[str, Field(min_length=1, strict=True, max_length=1000)] = Field(description="The name of the event you're tracking. This must be whitelisted in the Ours dashboard.")
    token: Annotated[str, Field(min_length=1, strict=True, max_length=250)] = Field(description="The token for your Ours Privacy Source. You can find this in the Ours dashboard.")
    user_id: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=400)]] = Field(default=None, description="The Ours user id stored in local storage and cookies on your web properties. If userId is included in the request, we do not lookup the user by email or externalId.", alias="userId")
    external_id: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=400)]] = Field(default=None, description="The externalId (the ID in your system) of a user. We will associate this event with the user or create a user. If included in the request, email lookup is ignored.", alias="externalId")
    email: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1000)]] = Field(default=None, description="The email address of a user. We will associate this event with the user or create a user. Used for lookup if externalId and userId are not included in the request.")
    event_properties: Optional[Dict[str, Any]] = Field(default=None, description="Any additional event properties you want to pass along.", alias="eventProperties")
    user_properties: Optional[TrackRequestUserProperties] = Field(default=None, alias="userProperties")
    default_properties: Optional[TrackRequestDefaultProperties] = Field(default=None, alias="defaultProperties")
    distinct_id: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=400)]] = Field(default=None, description="A unique identifier for the event. This helps prevent duplicate events.", alias="distinctId")
    __properties: ClassVar[List[str]] = ["event", "token", "userId", "externalId", "email", "eventProperties", "userProperties", "defaultProperties", "distinctId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TrackRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of user_properties
        if self.user_properties:
            _dict['userProperties'] = self.user_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of default_properties
        if self.default_properties:
            _dict['defaultProperties'] = self.default_properties.to_dict()
        # set to None if user_id (nullable) is None
        # and model_fields_set contains the field
        if self.user_id is None and "user_id" in self.model_fields_set:
            _dict['userId'] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict['externalId'] = None

        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict['email'] = None

        # set to None if event_properties (nullable) is None
        # and model_fields_set contains the field
        if self.event_properties is None and "event_properties" in self.model_fields_set:
            _dict['eventProperties'] = None

        # set to None if user_properties (nullable) is None
        # and model_fields_set contains the field
        if self.user_properties is None and "user_properties" in self.model_fields_set:
            _dict['userProperties'] = None

        # set to None if default_properties (nullable) is None
        # and model_fields_set contains the field
        if self.default_properties is None and "default_properties" in self.model_fields_set:
            _dict['defaultProperties'] = None

        # set to None if distinct_id (nullable) is None
        # and model_fields_set contains the field
        if self.distinct_id is None and "distinct_id" in self.model_fields_set:
            _dict['distinctId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TrackRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "event": obj.get("event"),
            "token": obj.get("token"),
            "userId": obj.get("userId"),
            "externalId": obj.get("externalId"),
            "email": obj.get("email"),
            "eventProperties": obj.get("eventProperties"),
            "userProperties": TrackRequestUserProperties.from_dict(obj["userProperties"]) if obj.get("userProperties") is not None else None,
            "defaultProperties": TrackRequestDefaultProperties.from_dict(obj["defaultProperties"]) if obj.get("defaultProperties") is not None else None,
            "distinctId": obj.get("distinctId")
        })
        return _obj


